/***************************************************************************
 functions.cc  -  description
 -------------------
 begin                : Fri Dec  6 15:19:06 PST 2002
 copyright            : (C) 2002 by Oleksiy Kohany
 email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include "functions.h"
#include <stdarg.h>

using namespace std;

//==============================================================
void libutil_main()
{
}
//==============================================================
int getoptions(char **argv, ARGMAP& argmap, int argc, ...)
{
   va_list ap;
   va_start(ap, argc);
   const char* aptr = va_arg(ap, const char*);
   for(; (aptr != 0 && argc-- > 0); aptr = va_arg(ap, const char*))
   {
      for(char** cpptr1 = argv; *cpptr1 != 0; cpptr1++)
      {
         char** cpptr2 = cpptr1;
         if(strstr(*cpptr1, aptr) == *cpptr1)
         {
            if(strcmp(*cpptr1, aptr) == 0)
            {
               if(cpptr1[1] == 0)
               {
                  fprintf(stderr, "Bad argument to %s option\n", aptr);
                  return -1;
               }
               argmap[aptr] = cpptr1[1];
               cpptr2 = cpptr1 + 2;
            }
            else
            {
               argmap[aptr] = *cpptr1 + strlen(aptr);
               cpptr2 = cpptr1 + 1;
            }
            char** wptr;
            char** rptr;
            for(wptr = cpptr1, rptr = cpptr2; *rptr != 0; wptr++, rptr++)
            {
               *wptr = *rptr;
            }
            cpptr1--;
            *wptr = 0;
         }
      }
   }
   return argmap.size();
}
//==============================================================
int getflags(char **argv, ARGMAP& argmap, int argc, ...)
{
   va_list ap;
   va_start(ap, argc);
   const char* aptr = va_arg(ap, const char*);
   char** cpptr1;
   char** wptr;
   char** rptr;
   for(; aptr != 0 && argc > 0; aptr = va_arg(ap, const char*), argc--)
   {
      for(cpptr1 = argv; *cpptr1 != 0; cpptr1++)
      {
         if(strcmp(*cpptr1, aptr) == 0 && strlen(*cpptr1) == strlen(aptr))
         {
            argmap[aptr] = "";
            for(wptr = rptr = cpptr1, rptr++; *rptr != 0; wptr++, rptr++)
            {
               *wptr = *rptr;
            }
            cpptr1--;
            *wptr = 0;
         }
      }
   }
   return argmap.size();
}
//==============================================================
char* squeeze(char* line)
{
   char *p_write = line;
   char *p_read;
   for (p_read = line; isgraph(*p_read); p_read++)
      ;
   for (; *p_read != 0; p_read++)
   {
      if (isgraph(*p_read))
      {
         *p_write++ = *p_read;
      }
   }
   *p_write = '\0';
   return p_write;
}
//==============================================================
char* squeeze(char* line, char cSqz)
{
   char *p_write = line;
   char *p_read;
   for (p_read = line; *p_read == cSqz; p_read++)
      ;
   for (; *p_read != 0; p_read++)
   {
      if (*p_read != cSqz || *(p_read + 1) != cSqz)
      {
         *p_write++ = *p_read;
      }
   }
   *p_write = '\0';
   return p_write;
}
//==============================================================
bool starts_with(const char* line, const char* pattern)
{
   const char *ptr1, *ptr2;
   ptr1 = line;
   ptr2 = pattern;
   while ((*ptr1 != '\0') && (*ptr2 != '\0'))
   {
      if (*ptr1++ != *ptr2++)
      {
         return false;
      }
   }
   if (*ptr2 == '\0')
   {
      return true;
   }
   else
   {
      return false;
   }
}
//==============================================================
int uirand(unsigned int maxval)
{
   return round(double(rand()) * maxval / RAND_MAX);
}
//==============================================================
const char* getColumn(const char* line, int num)
{
   const char *ptr = line;
   for (int i = 1; i < num; i++)
   {
      for (; !isgraph(*ptr) && *ptr != '\0' && *ptr != '\n'; ptr++)
         ;
      for (; isgraph(*ptr) && *ptr != '\0' && *ptr != '\n'; ptr++)
         ;
   }
   return ptr;
}
//==============================================================
char** assigninput(FILE* &F, char** argv)
{
   if (argv[1] != 0 && argv[1][0] == '-')
   {
      F = stdin;
      return argv + 1;
   }
   if (argv[1] == 0)
   {
      return 0;
   }
   if ((F = fopen(argv[1], "r")) == 0)
   {
      fprintf(stderr, "Bad file name %s\n", argv[1]);
      return 0;
   }
   return (argv + 1);
}
//==============================================================
FILE* assigninput(FILE* &F, const char* fname)
{
   if (fname == 0)
   {
      return 0;
   }
   if (fname[0] == '-' && fname[1] == '\0')
   {
      F = stdin;
      return F;
   }
   if ((F = fopen(fname, "r")) == 0)
   {
      fprintf(stderr, "Bad file name %s\n", fname);
      return 0;
   }
   return F;
}
//==============================================================
FILE* assigninput(FILE* &F, const string& fname)
{
   return assigninput(F, fname.c_str());
}
//==============================================================
char** assigninput(istream* &fin, char** argv)
{
   if (argv[1] == 0)
   {
      return 0;
   }
   if (argv[1][0] == '-')
   {
      fin = &cin;
      return argv + 1;
   }
   fin = new ifstream(argv[1]);
   if ((fin->bad()))
   {
      cerr << "Failed to open " << argv[1] << " for reading\n";
      return 0;
   }
   return (argv + 1);
}
//==============================================================
istream* assigninput(istream *&fin, const char* fname)
{
   if (fname == 0)
   {
      return 0;
   }
   if (fname[0] == '-' && fname[1] == '\0')
   {
      fin = &cin;
      return fin;
   }
   fin = new ifstream(fname);
   if ((fin->bad()))
   {
      cerr << "Failed to open " << fname << " for reading\n";
      return 0;
   }
   return fin;
}
//==============================================================
istream* assigninput(istream *&fin, const string& fname)
{
   return assigninput(fin, fname.c_str());
}
//==============================================================
ostream* assignoutput(ostream* &fout, const char* fname)
{
   if (fname == 0)
   {
      return 0;
   }
   if (fname[0] == '-' && fname[1] == '\0')
   {
      fout = &cout;
   }
   else
   {
      fout = new ofstream(fname);
      if ((fout->bad()))
      {
         cerr << "Failed to open " << fname << " for writing\n";
         return 0;
      }
   }
   return fout;
}
//==============================================================
ostream* assignoutput(ostream* &fout, const string& fname)
{
   return assignoutput(fout, fname.c_str());
}
//==============================================================
char** assignoutput(ostream* &fout, char** argv)
{
   if (argv[1] != 0 && argv[1][0] == '-')
   {
      fout = &cout;
      return argv + 1;
   }
   if (argv[1] == 0)
   {
      fout = &cout;
      return argv;
   }
   if (assignoutput(fout, argv[1]) == 0)
   {
      return 0;
   }
   return (argv + 1);
}
//==============================================================
FILE* assignoutput(FILE* &F, const char* fname)
{
   if (fname == 0)
   {
      return 0;
   }
   if (fname[0] == '-' && fname[1] == '\0')
   {
      F = stdout;
   }
   else
   {
      if ((F = fopen(fname, "w")) == 0)
      {
         fprintf(stderr, "Failed to open %s for writing\n", fname);
         return 0;
      }
   }
   return F;
}
//==============================================================
FILE* assignoutput(FILE* &F, const string& fname)
{
   return assignoutput(F, fname.c_str());
}
//==============================================================
char** assignoutput(FILE* &F, char** argv)
{
   if (argv[1] != 0 && argv[1][0] == '-')
   {
      F = stdout;
      return argv + 1;
   }
   if (argv[1] == 0)
   {
      F = stdout;
      return argv;
   }
   if (assignoutput(F, argv[1]) == 0)
   {
      return 0;
   }
   return (argv + 1);
}
//==============================================================
FILE* openofilename(const char* fname)
{
   FILE *F;
   if (fname == 0)
   {
      return 0;
   }
   if ((F = fopen(fname, "w")) == 0)
   {
      fprintf(stderr, "Failed to open %s for writing\n", fname);
      return 0;
   }
   return F;
}

//==============================================================
FILE* openifilename(const char* fname)
{
   FILE *F;
   if (fname == 0)
   {
      return 0;
   }
   if ((F = fopen(fname, "r")) == 0)
   {
      fprintf(stderr, "Failed to open %s for reading\n", fname);
      return 0;
   }
   return F;
}
//==============================================================
ofstream* openofs(const char* fname)
{
   ofstream *os;
   if (fname == 0)
   {
      return 0;
   }
   os = new ofstream(fname);
   if (os->fail())
   {
      cerr << "Failed to open " << fname << " for writing\n";
      return 0;
   }
   return os;
}
//==============================================================
ifstream* openifs(const char* fname)
{
   ifstream *is;
   if (fname == 0)
   {
      return 0;
   }
   is = new ifstream(fname);
   if (is->fail())
   {
      cerr << "Failed to open " << fname << " for reading\n";
      return 0;
   }
   return is;
}
//==============================================================
char convert_esc(char* line)
{
   if (line[0] == '\\')
   {
      switch (line[1])
      {
         case 'a':
            return '\a';
         case 'b':
            return '\b';
         case 'f':
            return '\f';
         case 'n':
            return '\n';
         case 'r':
            return '\r';
         case 't':
            return '\t';
         case 'v':
            return '\v';
         default:
            return line[1];
      }
   }
   return *line;
}
//==============================================================
char* convertline(char* line)
{
   char *rptr = line;
   char *wptr = line;
   while (rptr[0] != '\0')
   {
      if (rptr[0] == '\\')
      {
         *wptr++ = convert_esc(rptr);
         rptr++;
      }
      else
      {
         *wptr++ = *rptr;
      }
      rptr++;
   }
   *wptr = '\0';
   return line;
}
//==============================================================
bool isEmpty(char* line)
{
   do
   {
      if (isgraph(*line)) return false;
   } while (*line++ != '\0');
   return true;
}
//================================================================
void error(const char* message)
{
   fprintf(stderr, message);
   exit(-1);
}
//================================================================
void print_ft(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, double dScore, double dSim,
              double dTranz, bool isDirect)
{
   os << setw(12) << setiosflags(ios::left) << pcTgtName << " " << setw(7) << resetiosflags(ios::left) << iTgtFrom << " " << setw(7) << setiosflags(ios::left)
            << iTgtTo << " ";
   os << setw(12) << setiosflags(ios::left) << pcRepName << " " << setw(7) << resetiosflags(ios::left) << iRepFrom << " " << setw(7) << setiosflags(ios::left)
            << iRepTo << " ";
   os << (isDirect ? 'd' : 'c') << "   " << setw(5) << setprecision(4) << dSim << " ";
   //	os<<setw(5)<<setprecision(2)<<dTranz<<" ";
   (dTranz < 0.1) ? (os << setw(5) << dTranz << " ") : (os << setw(5) << setprecision(2) << dTranz << " ");
   os << setprecision(2) << setw(7) << setiosflags(ios::left) << dScore << "\n";
}
//================================================================
void print_ft(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, double dScore, double dSim,
              double dTranz, bool isDirect, double percent1, double percent2)
{
   os << setw(12) << left << pcTgtName << " " << setw(7) << right << iTgtFrom << " " << setw(7) << left << iTgtTo << " ";
   os << setw(12) << left << pcRepName << " " << setw(7) << right << iRepFrom << " " << setw(7) << left << iRepTo << " ";
   os << (isDirect ? 'd' : 'c') << "   " << setw(5) << setprecision(4) << dSim << " ";
   (dTranz < 0.1) ? (os << setw(5) << dTranz << " ") : (os << setw(5) << setprecision(2) << dTranz << " ");
   if(dScore < 1.0) {
	   os << scientific;
   }
   else {
	   os << fixed << setprecision(0);
   }

   os << setw(8) << right << dScore << " ";
   os << fixed << setprecision(2) << setw(7) << right << percent1 << " " << setw(7) << right << percent2 << "\n";
}
//================================================================
int read_ft(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo, char *pcRepName, long &iRepFrom, long &iRepTo, int &iScore, double &dSim,
            double &dTranz)
{
   char cDir;
   double dTgtFrom, dTgtTo, dRepFrom, dRepTo, dScore;
   int iRes = sscanf(pcLine, "%s %lf %lf %s %lf %lf %c %lf %lf %lf", pcTgtName, &dTgtFrom, &dTgtTo, pcRepName, &dRepFrom, &dRepTo, &cDir, &dSim, &dTranz,
                     &dScore);
   iTgtFrom = long(dTgtFrom);
   iTgtTo = long(dTgtTo);
   iRepFrom = long(dRepFrom);
   iRepTo = long(dRepTo);
   iScore = int(dScore);
   switch (cDir)
   {
      case 'd':
         strcat(pcRepName, "@1");
         break;
      case 'c':
         strcat(pcRepName, "@2");
         break;
      default:
         return 0;
   }
   return iRes - 1;
}
//================================================================
void print_ft(FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, double dScore, double dSim,
              double dTranz, bool isDirect, double percent1, double percent2)
{
   char cDir = 'c';
   if (isDirect)
   {
      cDir = 'd';
   }
   string format("%-12s %7ld %-7ld %12s %7ld %-7ld %c   %-5.4f ");
   format += dTranz < 0.1 ? "%-5.2e " : "%-5.2f ";
   format += dScore < 1.0 ? "%-5.2e " : "%-5.2f\t";
   format += "%f\t%f\n";
   //  fprintf(FOUT, "%-12s %7ld %-7ld %12s %7ld %-7ld %c   %-5.2f %-5.2f %.0f\n",
   fprintf(FOUT, format.c_str(), pcTgtName, iTgtFrom, iTgtTo, pcRepName, iRepFrom, iRepTo, cDir, dSim, dTranz, dScore, percent1, percent2);
}
//================================================================
void print_ft(FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, double dScore, double dSim,
              double dTranz, bool isDirect)
{
   char cDir = 'c';
   if (isDirect)
   {
      cDir = 'd';
   }
   //  fprintf(FOUT, "%-12s %7ld %-7ld %12s %7ld %-7ld %c   %-5.2f %-5.2f %.0f\n",
   fprintf(FOUT, "%-12s %7ld %-7ld %12s %7ld %-7ld %c   %-5.4f ", pcTgtName, iTgtFrom, iTgtTo, pcRepName, iRepFrom, iRepTo, cDir, dSim);
   (dTranz < 0.1) ? (fprintf(FOUT, "%-5.2e %.0f\n", dTranz, dScore)) : (fprintf(FOUT, "%-5.2f %.0f\n", dTranz, dScore));
}
//read_ft(char*, char*, long&, long&, char*, long&, long&, int&, double&, double&, bool)
//================================================================
int read_ft(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo, char *pcRepName, long &iRepFrom, long &iRepTo, double &dScore, double &dSim,
            double &dTranz, bool &isDirect)
{
   char cDir;
   double dTgtFrom, dTgtTo, dRepFrom, dRepTo;
   int iRes = sscanf(pcLine, "%s %lf %lf %s %lf %lf %c %lf %lf %lf", pcTgtName, &dTgtFrom, &dTgtTo, pcRepName, &dRepFrom, &dRepTo, &cDir, &dSim, &dTranz,
                     &dScore);
   iTgtFrom = long(dTgtFrom);
   iTgtTo = long(dTgtTo);
   iRepFrom = long(dRepFrom);
   iRepTo = long(dRepTo);
   isDirect = (cDir == 'd');
   return iRes - 1;
}
//================================================================
void print_co(FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, int iScore)
{
   fprintf(FOUT, "%-5d %-12s %7ld > %-7ld %12s %7ld > %-7ld\n", iScore, pcRepName, iRepFrom, iRepTo, pcTgtName, iTgtFrom, iTgtTo);
   //	  iScore, pcTgtName, iTgtFrom, iTgtTo, pcRepName, iRepFrom, iRepTo);
}
//================================================================
void print_co(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo, const char *pcRepName, long iRepFrom, long iRepTo, int iScore)
{
   os << setw(5) << setiosflags(ios::left) << iScore << " ";
   os << setw(12) << pcRepName << " " << setw(7) << iRepFrom << setw(7) << setiosflags(ios::left) << iRepTo;
   os << setw(12) << pcTgtName << " " << setw(7) << iTgtFrom << setw(7) << setiosflags(ios::left) << iTgtTo << "\n";
}
//================================================================
int read_co(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo, char *pcRepName, long &iRepFrom, long &iRepTo, int &iScore)
{
   char sTrash[10];
   return sscanf(pcLine, "%d %s %ld %s %ld %s %ld %s %ld", &iScore, pcRepName, &iRepFrom, sTrash, &iRepTo, pcTgtName, &iTgtFrom, sTrash, &iTgtTo) - 1;
   //		&iScore, pcTgtName, &iTgtFrom, sTrash, &iTgtTo, pcRepName, &iRepFrom, sTrash, &iRepTo) - 1;
}
//================================================================
bool exist(char *pcFName)
{
   FILE *FIN;
   if ((FIN = fopen(pcFName, "r")) == 0)
   {
      return false;
   }
   fclose(FIN);
   return true;
}
//================================================================
char transpose(const char c)
{
   switch (c)
   {
      case 'a':
         return 't';
      case 'A':
         return 'T';
      case 't':
         return 'a';
      case 'T':
         return 'A';
      case 'c':
         return 'g';
      case 'C':
         return 'G';
      case 'g':
         return 'c';
      case 'G':
         return 'C';
      default:
         return c;
   }
}
//================================================================
void printHeader(FILE *FOUT, const char *pcName)
{
#ifdef FASTA
   fprintf(FOUT, ">%s\n", pcName);
#else

   fprintf(FOUT, ";\n%s\n", pcName);
#endif
}
//================================================================
int readline(char *buff, unsigned long size, FILE* is)
{
   char *ptr;
   if (fgets(buff, size, is))
   {
      ptr = buff + strlen(buff) - 1;
      if (*ptr == '\n')
      {
         *ptr = '\0';
      }
      return 0;
   }
   return 1;
}
//================================================================
int readline(char *buff, unsigned long size, istream* is)
{
   if (is->getline(buff, size).fail())
   {
      return 1;
   }
   return 0;
}
//================================================================
char* toUpper(char *s)
{
   if (s != 0)
   {
      for (char *ptr = s; *ptr != '\0'; ptr++)
      {
         *ptr = toupper(*ptr);
      }
   }
   return s;
}
//================================================================
string& toUpper(string &s)
{
   for (string::iterator sptr = s.begin(); sptr != s.end(); sptr++)
   {
      *sptr = toupper(*sptr);
   }
   return s;
}
