/***************************************************************************
                          functions.h  -  description
                             -------------------
    begin                : Fri Dec  6 15:19:06 PST 2002
    copyright            : (C) 2002 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FUNCTIONS_H_
#define _FUNCTIONS_H_

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <math.h>
#include <map>
#include <string>

using namespace std;

/*
#ifndef _min
#define _min(x,y)   ( (x) <= (y) ? (x) : (y) )
#endif
#ifndef _max
#define _max(x,y)   ( (x) >= (y) ? (x) : (y) )
#endif
*/
#ifndef round
#define round(x) ( x < 0 ? \
    (x - int(x) < -0.5) ? int(x) - 1 : int(x) : \
    (x - int(x) < 0.5) ? int(x) : int(x) + 1 )
#endif

typedef map<string, string> ARGMAP;

//==============================================================
void libutil_main();
//==============================================================
int getoptions(char **argv, ARGMAP& argmap, int argc,...);
//==============================================================
int getflags(char **argv, ARGMAP& argmap, int argc,...);
//==============================================================
char* squeeze(char* line);
//==============================================================
char* squeeze(char* line, char cSqz);
//==============================================================
bool starts_with(const char* line, const char* pattern);
//==============================================================
int uirand(unsigned int maxval);
//==============================================================
const char* getColumn(const char* line, int num);
//==============================================================
char** assigninput(::FILE* &F, char** argv);
char** assigninput(istream* &fi, char** argv);
FILE* assigninput(FILE* &F, const char* fname);
FILE* assigninput(FILE* &F, const string& fname);
istream* assigninput(istream *&is, const char* fname);
istream* assigninput(istream *&is, const string& fname);
//==============================================================
char** assignoutput(ostream* &fo, char** argv);
char** assignoutput(FILE* &F, char** argv);
ostream* assignoutput(ostream* &fout, const char* fname);
ostream* assignoutput(ostream* &fout, const string& fname);
FILE* assignoutput(FILE* &F, const char* fname);
FILE* assignoutput(FILE* &F, const string& fname);
//==============================================================
FILE* openofilename(const char* fname);
//==============================================================
FILE* openifilename(const char* fname);
//==============================================================
ofstream* openofs(const char* fname);
//==============================================================
ifstream* openifs(const char* fname);
//==============================================================
char convert_esc(char* line);
//==============================================================
char *convertline(char* line);
//==============================================================
bool isEmpty(char* line);
//================================================================
void error(const char* message);
//================================================================
void print_ft(FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo, double dScore,
              double dSim, double dTranz, bool isDirect);
//================================================================
void print_ft(FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo, double dScore,
              double dSim, double dTranz, bool isDirect, double cvg1, double cvg2);
//================================================================
void print_ft(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo,
              double dScore, double dSim, double dTranz, bool isDirect);
//================================================================
void print_ft(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo,
              double dScore, double dSim, double dTranz, bool isDirect, double cvg1, double cvg2);
//================================================================
int read_ft(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo,
            char *pcRepName, long &iRepFrom, long &iRepTo, double &dScore,
            double &dSim, double &dTranz);
//================================================================
int read_ft(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo,
            char *pcRepName, long &iRepFrom, long &iRepTo, double &dScore,
            double &dSim, double &dTranz, bool &isDirect);
//================================================================
void print_co(::FILE *FOUT, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo, int iScore);
//================================================================
void print_co(ostream &os, const char *pcTgtName, long iTgtFrom, long iTgtTo,
              const char *pcRepName, long iRepFrom, long iRepTo, int iScore);
//================================================================
int read_co(char *pcLine, char *pcTgtName, long &iTgtFrom, long &iTgtTo,
            char *pcRepName, long &iRepFrom, long &iRepTo, int &iScore);
//================================================================
bool exist(char *pcFName);
//================================================================
char transpose(const char c);
//================================================================
void printHeader(::FILE *FOUT, const char *pcName);
//================================================================
int readline(char *buff, unsigned long size, FILE* is);
//================================================================
int readline(char *buff, unsigned long size, istream* is);
//================================================================
char* toUpper(char *s);
//================================================================
string& toUpper(string &s);
//================================================================
#endif //_FUNCTIONS_H_
